Bug 1821189 - Package Review: Snakemake - Workflow management system to create reproducible and scalable data analyses
Summary: Package Review: Snakemake - Workflow management system to create reproducible...
Keywords:
Status: ASSIGNED
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Hirotaka Wakabayashi
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1871824 1871825 1931046
Blocks: fedora-neuro
TreeView+ depends on / blocked
 
Reported: 2020-04-06 09:26 UTC by Aniket Pradhan
Modified: 2021-03-02 07:15 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug
hiwkby: fedora-review?


Attachments (Terms of Use)

Description Aniket Pradhan 2020-04-06 09:26:35 UTC
Spec URL: https://major.fedorapeople.org/snakemake/snakemake.spec
SRPM URL: https://major.fedorapeople.org/snakemake/snakemake-5.12.3-1.fc32.src.rpm

The docs aren't building properly right now. I have filed a ticket upstream for the same. I will include it in a subpackage as soon as it gets fixed.
Ticket: https://github.com/snakemake/snakemake/issues/296

I am also not sure if I should prefix a "python-" before the name of the package as well, given snakemake is not a Python library or module.

Comment 1 Hirotaka Wakabayashi 2020-05-30 23:35:24 UTC
Here is a successful Koji scratch build.
https://koji.fedoraproject.org/koji/taskinfo?taskID=45202961

Comment 2 Hirotaka Wakabayashi 2020-06-06 07:12:40 UTC
Hello Aniket,

Thank you for submitting the package. As you say, this package needs no
"python" prefix because this package is not a library package. Please see:
https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_naming

Please check my review and ask if you have any questions. I checked this 
package but I couldn't install it because of dependency problem... rpmlint
is a very useful to detect common errors. Please see:
https://docs.fedoraproject.org/en-US/packaging-guidelines/#_use_rpmlint

Thanks in advance,
Hirotaka Wakabayashi

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Source0
  Please make sure the source code url is available.
  ```
  $ wget https://github.com/aflc/snakemake/archive/v5.12.3/snakemake-5.12.3.tar.gz
  --2020-06-05 22:19:21--  https://github.com/aflc/snakemake/archive/v5.12.3/snakemake-5.12.3.tar.gz
  Resolving github.com (github.com)... 52.192.72.89
  Connecting to github.com (github.com)|52.192.72.89|:443... connected.
  HTTP request sent, awaiting response... 404 Not Found
  2020-06-05 22:19:21 ERROR 404: Not Found.
  ```
  You can use the %pypi_source macro. Please see:
  https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_source_files_from_pypi
- Dependencies
  Please check dependent packages. Some packages don't seem to exist.
  ```
  $ sudo dnf install -y ~/rpmbuild/RPMS/x86_64/snakemake-5.12.3-1.fc33.x86_64.rpm 
  Last metadata expiration check: 0:49:45 ago on Fri 05 Jun 2020 10:06:39 PM UTC.
  Error: 
   Problem: conflicting requests
    - nothing provides python3.9dist(datrie) needed by snakemake-5.12.3-1.fc33.x86_64
    - nothing provides python3.9dist(ratelimiter) needed by snakemake-5.12.3-1.fc33.x86_64
    - nothing provides python3.9dist(toposort) needed by snakemake-5.12.3-1.fc33.x86_64
  ```
  You can see the list of dependencies:
  $ rpm -qp --requires  snakemake-5.12.3-1.fc33.x86_64.rpm 
- Version
  Please update the version if newer version exists.
- BuildRequires
  "gcc-c++" is not needed if you don't build c/c++ applications.
  "python-unversioned-command" is probably not needed because packages on Fedora
  doesn't directly use /usr/bin/python.
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/
- Packages MUST NOT have dependencies (either build-time or runtime) on
  packages named with the unversioned python- prefix unless no properly
  versioned package exists. Dependencies on Python packages instead MUST
  use names beginning with python2- or python3- as appropriate.
  Note: Unversionned Python dependency found.
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/Python/#_dependencies
  
===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[?]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License", "*No copyright* Expat
     License". 682 files have unknown license. Detailed output of
     licensecheck in
     /home/vagrant/FedoraReview/1821189-snakemake/licensecheck.txt
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Macros in Summary, %description expandable at SRPM build time.
     Note: Macros in: snakemake (description)
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.

[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[!]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[!]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[!]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: Sources can be downloaded from URI in Source: tag
     Note: Could not download Source0:
     https://github.com/aflc/snakemake/archive/v5.12.3/snakemake-5.12.3.tar.gz
     See: https://docs.fedoraproject.org/en-US/packaging-
     guidelines/SourceURL/
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[?]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[!]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[!]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: https://docs.fedoraproject.org/en-US/packaging-
     guidelines/#_use_rpmlint
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 2.3 starting (python version = 3.9.0)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
INFO: Signal handler active
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled package manager cache
Start: cleaning package manager metadata
Finish: cleaning package manager metadata
INFO: enabled HW Info plugin
Mock Version: 2.3
INFO: Mock Version: 2.3
Finish: chroot init
INFO: installing package(s): /home/vagrant/FedoraReview/1821189-snakemake/results/snakemake-5.12.3-1.fc33.x86_64.rpm
ERROR: Command failed: 
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 33 --setopt=deltarpm=False --allowerasing --disableplugin=local --disableplugin=spacewalk install /home/vagrant/FedoraReview/1821189-snakemake/results/snakemake-5.12.3-1.fc33.x86_64.rpm --setopt=tsflags=nocontexts



Rpmlint
-------
Checking: snakemake-5.12.3-1.fc33.x86_64.rpm
          snakemake-5.12.3-1.fc33.src.rpm
snakemake.x86_64: W: spelling-error Summary(en_US) Workflow -> Work flow, Work-flow, Workforce
snakemake.x86_64: W: unexpanded-macro %description -l C %python_provide
snakemake.x86_64: W: spelling-error %description -l en_US workflow -> work flow, work-flow, workforce
snakemake.x86_64: W: spelling-error %description -l en_US Workflows -> Work flows, Work-flows, Workloads
snakemake.x86_64: W: spelling-error %description -l en_US workflows -> work flows, work-flows, workloads
snakemake.x86_64: E: no-binary
snakemake.x86_64: E: non-executable-script /usr/lib/python3.9/site-packages/snakemake/jobscript.sh 644 /bin/sh 
snakemake.x86_64: W: no-manual-page-for-binary snakemake
snakemake.x86_64: W: no-manual-page-for-binary snakemake-bash-completion
snakemake.src: W: spelling-error Summary(en_US) Workflow -> Work flow, Work-flow, Workforce
snakemake.src: W: spelling-error %description -l en_US workflow -> work flow, work-flow, workforce
snakemake.src: W: spelling-error %description -l en_US Workflows -> Work flows, Work-flows, Workloads
snakemake.src: W: spelling-error %description -l en_US workflows -> work flows, work-flows, workloads
snakemake.src:68: W: mixed-use-of-spaces-and-tabs (spaces: line 14, tab: line 68)
snakemake.src: W: invalid-url Source0: https://github.com/aflc/snakemake/archive/v5.12.3/snakemake-5.12.3.tar.gz HTTP Error 404: Not Found
2 packages and 0 specfiles checked; 2 errors, 13 warnings.




Requires
--------
snakemake (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3.9dist(appdirs)
    python3.9dist(configargparse)
    python3.9dist(datrie)
    python3.9dist(docutils)
    python3.9dist(gitpython)
    python3.9dist(jsonschema)
    python3.9dist(nbformat)
    python3.9dist(psutil)
    python3.9dist(pyyaml)
    python3.9dist(ratelimiter)
    python3.9dist(requests)
    python3.9dist(setuptools)
    python3.9dist(toposort)
    python3.9dist(wrapt)



Provides
--------
snakemake:
    python3.9dist(snakemake)
    python3dist(snakemake)
    snakemake
    snakemake(x86-64)



Generated by fedora-review 0.7.5 (cd5b7df) last change: 2020-03-19
Command line :try-fedora-review -b 1821189
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, C/C++, Generic, Shell-api
Disabled plugins: SugarActivity, Ocaml, Java, R, PHP, Perl, fonts, Ruby, Haskell
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 3 Aniket Pradhan 2020-06-06 13:51:27 UTC
Hey Hirotaka,

Sorry I got a bit late. Most of these issues starting coming up recently and many updates have come through since I put up this review. I'll update the version first, and then I'll try to work upon the edits. I will update on this ticket when I'm done.

Thanks a lot, for taking up this review. :D

Comment 4 Aniket Pradhan 2020-06-18 13:44:33 UTC
Hello Hirotaka

Finally got some time to boot up my Fedora system, so I spent some time fixing this :D



> - Source0
>   Please make sure the source code url is available.
>   ```
>   $ wget
> https://github.com/aflc/snakemake/archive/v5.12.3/snakemake-5.12.3.tar.gz
>   --2020-06-05 22:19:21-- 
> https://github.com/aflc/snakemake/archive/v5.12.3/snakemake-5.12.3.tar.gz
>   Resolving github.com (github.com)... 52.192.72.89
>   Connecting to github.com (github.com)|52.192.72.89|:443... connected.
>   HTTP request sent, awaiting response... 404 Not Found
>   2020-06-05 22:19:21 ERROR 404: Not Found.
>   ```
>   You can use the %pypi_source macro. Please see:

Fixed the source to upstream release


> - Dependencies
>   Please check dependent packages. Some packages don't seem to exist.
>   ```
>   $ sudo dnf install -y
> ~/rpmbuild/RPMS/x86_64/snakemake-5.12.3-1.fc33.x86_64.rpm 
>   Last metadata expiration check: 0:49:45 ago on Fri 05 Jun 2020 10:06:39 PM
> UTC.
>   Error: 
>    Problem: conflicting requests
>     - nothing provides python3.9dist(datrie) needed by
> snakemake-5.12.3-1.fc33.x86_64
>     - nothing provides python3.9dist(ratelimiter) needed by
> snakemake-5.12.3-1.fc33.x86_64
>     - nothing provides python3.9dist(toposort) needed by
> snakemake-5.12.3-1.fc33.x86_64
>   ```
>   You can see the list of dependencies:
>   $ rpm -qp --requires  snakemake-5.12.3-1.fc33.x86_64.rpm

I don't see these deps coming up now, so I guess it has been resolved with the new release.


> - Version
>   Please update the version if newer version exists.

Updated.


> - BuildRequires
>   "gcc-c++" is not needed if you don't build c/c++ applications.
>   "python-unversioned-command" is probably not needed because packages on
> Fedora
>   doesn't directly use /usr/bin/python.

You're right. I had used my old spec as a template and must have overlooked gcc-c++. Removed it.
python-unversioned-command is needed because a test calls `python` as a subprocess.


> - Package installs properly.
>   Note: Installation errors (see attachment)
>   See: https://docs.fedoraproject.org/en-US/packaging-guidelines/

It's installing fine now. Here's the koji scratch build [0].

[0]: https://koji.fedoraproject.org/koji/taskinfo?taskID=45855832


> - Packages MUST NOT have dependencies (either build-time or runtime) on
>   packages named with the unversioned python- prefix unless no properly
>   versioned package exists. Dependencies on Python packages instead MUST
>   use names beginning with python2- or python3- as appropriate.
>   Note: Unversionned Python dependency found.
>   See: https://docs.fedoraproject.org/en-US/packaging-
>   guidelines/Python/#_dependencies

I am quite unsure of what dependencies you're referring to here. Do you mean:
- rpmlib(CompressedFileNames) <= 3.0.4-1
- rpmlib(FileDigests) <= 4.6.0-1
These two deps are generated automatically by RPM I guess.



I have updated the spec and the SRPM on the previous links:

Spec: https://major.fedorapeople.org/snakemake/snakemake.spec
SRPM: https://major.fedorapeople.org/snakemake/snakemake-5.19.3-1.fc32.src.rpm

Thanks a lot for holding up for me... It has been long since I am using Fedora, mainly due to work :P

Comment 5 Hirotaka Wakabayashi 2020-06-27 07:02:41 UTC
Hello Aniket,

Thank you for your fixes, but there are some issues to fix. Please check my review.

1. Using `python` command

Could you please fix the code where `python` is used? because Fedora's
Python package guildelines says that "/usr/bin/python (as well as /usr/bin/env
python and similar) MUST NOT be used in shebang lines or as a dependency of a
package." Please see:
https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_multiple_python_runtimes

I think the code should be modified like this:
```
*** tests/test_linting.py.orig  2020-06-27 06:13:38.434409598 +0000
--- tests/test_linting.py       2020-06-27 06:13:50.992640111 +0000
***************
*** 18,24 ****
          out = (
              sp.check_output(
                  [
!                     "python",
                      "-m",
                      "snakemake",
                      "--lint",
--- 18,24 ----
          out = (
              sp.check_output(
                  [
!                     "python3",
                      "-m",
                      "snakemake",
                      "--lint",


```


2. Runtime dependencies

The spec file of this package contains unsatisfied runtime dependencies.
I think `datrie`, `ratelimiter` and `toposort` are also needed to submit
because they still don't exist in Fedora's repository[1].

As you know Koji is the software that builds RPM packages for the Fedora
project. We can confirm packages successfully build on Fedora supported
architectures by using Koji but we can't confirm correctness of runtime
dependencies.

Reviews must check where runtime dependencies[2] are met but runtime
dependencies of this package are unsatisfied in my environment(fc32).
```
$ sudo dnf install -y ~/rpmbuild/RPMS/x86_64/snakemake-5.19.3-1.fc32.x86_64.rpm
Last metadata expiration check: 1:29:53 ago on Sat 27 Jun 2020 04:57:44 AM UTC.
Error:
 Problem: conflicting requests
  - nothing provides python3.8dist(datrie) needed by snakemake-5.19.3-1.fc32.x86_64
  - nothing provides python3.8dist(ratelimiter) needed by snakemake-5.19.3-1.fc32.x86_64
  - nothing provides python3.8dist(toposort) needed by snakemake-5.19.3-1.fc32.x86_64
(try to add '--skip-broken' to skip uninstallable packages)
```

3. fedora-review report

Here is the output of fedora-review for reference. fedora-review tried to
install the binary package, but it failed to install it.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/
- If your application is a C or C++ application you must list a
  BuildRequires against gcc, gcc-c++ or clang.
  Note: No gcc, gcc-c++ or clang found in BuildRequires
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/C_and_C++/
- Packages MUST NOT have dependencies (either build-time or runtime) on
  packages named with the unversioned python- prefix unless no properly
  versioned package exists. Dependencies on Python packages instead MUST
  use names beginning with python2- or python3- as appropriate.
  Note: Unversionned Python dependency found.
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/Python/#_dependencies


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[?]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[!]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: https://docs.fedoraproject.org/en-US/packaging-
     guidelines/#_use_rpmlint
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 2.3 starting (python version = 3.8.3)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
INFO: Signal handler active
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled package manager cache
Start: cleaning package manager metadata
Finish: cleaning package manager metadata
INFO: enabled HW Info plugin
Mock Version: 2.3
INFO: Mock Version: 2.3
Finish: chroot init
INFO: installing package(s): /home/vagrant/FedoraReview/1821189-snakemake/results/snakemake-5.19.3-1.fc33.x86_64.rpm
ERROR: Command failed: 
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 33 --setopt=deltarpm=False --allowerasing --disableplugin=local --disableplugin=spacewalk install /home/vagrant/FedoraReview/1821189-snakemake/results/snakemake-5.19.3-1.fc33.x86_64.rpm --setopt=tsflags=nocontexts



Rpmlint
-------
Checking: snakemake-5.19.3-1.fc33.x86_64.rpm
          snakemake-5.19.3-1.fc33.src.rpm
snakemake.x86_64: W: spelling-error Summary(en_US) Workflow -> Work flow, Work-flow, Workforce
snakemake.x86_64: W: unexpanded-macro %description -l C %python_provide
snakemake.x86_64: W: spelling-error %description -l en_US workflow -> work flow, work-flow, workforce
snakemake.x86_64: W: spelling-error %description -l en_US Workflows -> Work flows, Work-flows, Workloads
snakemake.x86_64: W: spelling-error %description -l en_US workflows -> work flows, work-flows, workloads
snakemake.x86_64: E: no-binary
snakemake.x86_64: E: non-executable-script /usr/lib/python3.9/site-packages/snakemake/executors/jobscript.sh 644 /bin/sh 
snakemake.x86_64: W: no-manual-page-for-binary snakemake
snakemake.x86_64: W: no-manual-page-for-binary snakemake-bash-completion
snakemake.src: W: spelling-error Summary(en_US) Workflow -> Work flow, Work-flow, Workforce
snakemake.src: W: spelling-error %description -l en_US workflow -> work flow, work-flow, workforce
snakemake.src: W: spelling-error %description -l en_US Workflows -> Work flows, Work-flows, Workloads
snakemake.src: W: spelling-error %description -l en_US workflows -> work flows, work-flows, workloads
snakemake.src:67: W: mixed-use-of-spaces-and-tabs (spaces: line 14, tab: line 67)
2 packages and 0 specfiles checked; 2 errors, 12 warnings.




Source checksums
----------------
https://github.com/snakemake/snakemake/archive/v5.19.3/snakemake-5.19.3.tar.gz :
  CHECKSUM(SHA256) this package     : a971a6cbf0a7738faafb254d9a1093703a6811543295747a26183c833dc49ef3
  CHECKSUM(SHA256) upstream package : a971a6cbf0a7738faafb254d9a1093703a6811543295747a26183c833dc49ef3


Requires
--------
snakemake (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3.9dist(appdirs)
    python3.9dist(configargparse)
    python3.9dist(datrie)
    python3.9dist(docutils)
    python3.9dist(gitpython)
    python3.9dist(jsonschema)
    python3.9dist(nbformat)
    python3.9dist(psutil)
    python3.9dist(pyyaml)
    python3.9dist(ratelimiter)
    python3.9dist(requests)
    python3.9dist(setuptools)
    python3.9dist(toposort)
    python3.9dist(wrapt)



Provides
--------
snakemake:
    python3.9dist(snakemake)
    python3dist(snakemake)
    snakemake
    snakemake(x86-64)



Generated by fedora-review 0.7.5 (68531f4) last change: 2020-05-31
Command line :try-fedora-review -b 1821189
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, C/C++, Shell-api, Python
Disabled plugins: Java, Ocaml, PHP, Perl, Haskell, R, SugarActivity, Ruby, fonts
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH


Thanks in advance,
Hirotaka Wakabayashi

Comment 6 Aniket Pradhan 2020-07-02 07:34:31 UTC
Hey...

So, I added in a `sed .....` command to replace python with python3 in the required files.

Furthermore, it is kind of weird that there are no installation errors in the koji scratch build, given datrie, toposort and ratelimiter are not available in the Fedora repositories. These deps are mentioned in setup.py.

I'll try to package these deps as well, and will ping you here once its done. :D


Note You need to log in before you can comment on or make changes to this bug.